<script lang="ts">
import Vue, { PropType } from 'vue';
import type { BaseForm } from '~/interfaces';
import { OneTrustTroubleWarning } from '../common/index.vue';

export default Vue.extend({
  name: 'FreeTrialPlans',
  components: {
    OneTrustTroubleWarning,
  },
  props: {
    data: {
      type: Object as PropType<BaseForm>,
      required: true,
    },
  },
  data() {
    return {
      tabs: {
        saas: 'sass',
        self_managed: 'self-managed',
      },
      selectedTab: 'saas',
      submitted: false,
      cnbc_clicked: false,
    };
  },
  mounted() {
    const hosted = String(this.$route.query.hosted);
    if (hosted) {
      if (hosted.toLowerCase() === 'saas') {
        this.selectedTab = this.tabs.saas;
      } else if (hosted.toLowerCase() === 'self-managed') {
        this.selectedTab = this.tabs.self_managed;
      } else {
        this.selectedTab = this.tabs.saas;
      }
    } else {
      this.selectedTab = this.tabs.saas;
    }

    this.refreshForm();
  },
  methods: {
    onTabSelection(tabId) {
      this.selectedTab = tabId;
      this.$router.push({ query: { hosted: tabId } });
      this.$emit('update-data', tabId);
    },
    refreshForm() {
      window.MktoForms2.setOptions({
        formXDPath: '/rs/194-VVC-221/images/marketo-xdframe-relative.html',
      });
      window.MktoForms2.loadForm(
        '//page.gitlab.com',
        '194-VVC-221',
        this.data.self_managed.formId,
        (form) => {
          form.onSuccess(() => {
            this.$emit('submit');
            this.submitted = true;

            // eslint-disable-next-line no-undef
            dataLayer.push({
              event: 'trial',
              mktoFormId: form.getId(),
              eventCallback() {
                form.getFormElem().hide();
              },
              eventTimeout: 3000,
            });
            return false;
          });

          function getgacid() {
            try {
              // eslint-disable-next-line no-undef
              const tracker = ga.getAll()[0];
              return tracker.get('clientId');
            } catch (e) {
              return 'n/a';
            }
          }

          form.vals({
            gacid: getgacid(),
          });
        },
      );
    },
  },
});
</script>

<template>
  <section class="slp-mb-96">
    <script src="//page.gitlab.com/js/forms2/js/forms2.min.js"></script>
    <SlpContainer>
      <div class="plans">
        <div role="tablist" aria-label="Select your hosting plan">
          <button
            :id="tabs.saas"
            type="button"
            role="tab"
            :aria-selected="selectedTab === tabs.saas"
            aria-controls="saas-panel"
            :tabindex="selectedTab === tabs.saas ? '-1' : '0'"
            class="plans__link"
            :class="{ 'plans__link--active': selectedTab === tabs.saas }"
            @click="onTabSelection(tabs.saas)"
          >
            GitLab.com
          </button>
          <button
            :id="tabs.self_managed"
            type="button"
            role="tab"
            :aria-selected="selectedTab === tabs.self_managed"
            aria-controls="self-managed-panel"
            :tabindex="selectedTab === tabs.self_managed ? '-1' : '0'"
            class="plans__link"
            :class="{
              'plans__link--active': selectedTab === tabs.self_managed,
            }"
            @click="onTabSelection(tabs.self_managed)"
          >
            GitLab Self-Managed
          </button>
        </div>
        <div class="plans__content">
          <div
            v-show="selectedTab === tabs.saas"
            id="saas-panel"
            role="tabpanel"
            :aria-labelledby="tabs.saas"
          >
            <SlpTypography
              tag="h2"
              variant="heading5-bold"
              class="slp-py-24 slp-px-0 slp-px-md-24"
            >
              {{ data.saas.title }}
            </SlpTypography>
            <SlpTypography
              v-if="data.saas.subtitle"
              tag="p"
              variant="body1"
              class="plans__text slp-px-0 slp-px-md-24"
              >{{ data.saas.subtitle }}</SlpTypography
            >
            <div class="slp-flex slp-flex-column">
              <slp-button
                :href="data.saas.link.href"
                class="plans__button"
                :data-ga-name="data.saas.link.data_ga_name"
                :data-ga-location="data.saas.link.data_ga_location"
              >
                {{ data.saas.link.text }}
              </slp-button>
              <div
                v-if="data.saas.bottom_text"
                v-html="$md.render(data.saas.bottom_text)"
              ></div>
            </div>
          </div>
          <div
            v-show="selectedTab === tabs.self_managed"
            id="self-managed-panel"
            role="tabpanel"
            :aria-labelledby="tabs.self_managed"
          >
            <SlpTypography
              tag="h2"
              variant="heading5-bold"
              class="slp-py-24 slp-px-0 slp-px-md-24"
              >{{ data.self_managed.form_header }}</SlpTypography
            >
            <SlpTypography
              v-if="data.self_managed.blurb"
              tag="p"
              variant="body1"
              class="plans__text"
              >{{ data.self_managed.blurb }}</SlpTypography
            >

            <form
              v-if="!submitted"
              :id="`mktoForm_${data.self_managed.formId}`"
              class="mktoForm_container"
            />
            <div v-else>
              <p>
                {{
                  data.self_managed.confirmation ||
                  'Thanks for signing up for your free trial! You will get additional instructions in your inbox shortly.'
                }}
              </p>
            </div>
            <OneTrustTroubleWarning />
          </div>
        </div>
      </div>
    </SlpContainer>
  </section>
</template>

<style scoped lang="scss">
.plans {
  max-width: 540px;
  margin: 0 auto;
  overflow: hidden;
  display: flex;
  flex-direction: column;

  &__link {
    height: 56px;
    width: 50%;
    color: #333;
    font-size: 15px;
    text-align: center;
    float: left;
    cursor: pointer;
    outline: 0;
    padding: 10px 6px;
    transition: 0.3s;
    border-right: none;
    border-left: none;
    border-top: none;
    border-bottom: 1px solid #333;

    &:focus {
      outline: -webkit-focus-ring-color auto 1px;
    }

    @media (min-width: $breakpoint-sm) {
      font-size: 23px;
      padding: 14px 16px;
    }

    &--active {
      border: 1px solid #333;
      border-bottom: none;
      border-top-left-radius: 4px;
      border-top-right-radius: 4px;
      position: relative;
    }
  }

  &__tooltip {
    font-size: 23px;
    color: #333;
    border-width: 0 0 1px 0;
  }

  &__content {
    max-width: 540px;
    text-align: center;
    padding: $spacing-24;
    border: 1px solid #333;
    border-top: none;
    border-bottom-left-radius: 4px;
    border-bottom-right-radius: 4px;
  }

  &__text {
    padding-bottom: $spacing-16;
    margin-bottom: $spacing-24;
    border-bottom: 1px solid #333;
  }

  &__button {
    margin-bottom: $spacing-16;
    display: block;
  }
}
</style>
